/* Background.c generated by valac 0.48.13, the Vala compiler
 * generated from Background.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*-
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: Michael Terry
 */

#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <gdk/gdkx.h>
#include <gio/gio.h>
#include "deja.h"
#include <glib/gi18n-lib.h>

#define TYPE_BACKGROUND (background_get_type ())
#define BACKGROUND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKGROUND, Background))
#define BACKGROUND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKGROUND, BackgroundClass))
#define IS_BACKGROUND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKGROUND))
#define IS_BACKGROUND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKGROUND))
#define BACKGROUND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKGROUND, BackgroundClass))

typedef struct _Background Background;
typedef struct _BackgroundClass BackgroundClass;
typedef struct _BackgroundPrivate BackgroundPrivate;
enum  {
	BACKGROUND_0_PROPERTY,
	BACKGROUND_NUM_PROPERTIES
};
static GParamSpec* background_properties[BACKGROUND_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _BackgroundRequestAutostartData BackgroundRequestAutostartData;

struct _Background {
	GObject parent_instance;
	BackgroundPrivate * priv;
};

struct _BackgroundClass {
	GObjectClass parent_class;
};

struct _BackgroundRequestAutostartData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GtkWidget* widget;
	gboolean result;
	GtkWindow* window;
	GtkWidget* _tmp0_;
	GtkWindow* _tmp1_;
	gchar* mitigation;
	DejaDupInstallEnv* install_env;
	DejaDupInstallEnv* _tmp2_;
	gboolean allowed;
	DejaDupInstallEnv* _tmp3_;
	GtkWindow* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	const gchar* _tmp11_;
	GtkWindow* _tmp12_;
	const gchar* _tmp13_;
};

static gpointer background_parent_class = NULL;

GType background_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Background, g_object_unref)
static gchar* background_get_window_handle (GtkWindow* window);
static void background_request_autostart_data_free (gpointer _data);
void background_request_autostart (GtkWidget* widget,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_);
gboolean background_request_autostart_finish (GAsyncResult* _res_);
static gboolean background_request_autostart_co (BackgroundRequestAutostartData* _data_);
static void background_request_autostart_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_);
void deja_dup_run_error_dialog (GtkWindow* parent,
                                const gchar* header,
                                const gchar* message);
Background* background_new (void);
Background* background_construct (GType object_type);
static GType background_get_type_once (void);

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gchar*
background_get_window_handle (GtkWindow* window)
{
	GdkWindow* gdk_window = NULL;
	GdkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	GdkX11Window* x11_window = NULL;
	GdkWindow* _tmp2_;
	GdkX11Window* _tmp3_;
	GdkX11Window* _tmp4_;
	gchar* _tmp7_;
	gchar* result = NULL;
	g_return_val_if_fail (window != NULL, NULL);
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) window);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	gdk_window = _tmp1_;
	_tmp2_ = gdk_window;
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, gdk_x11_window_get_type ()) ? ((GdkX11Window*) _tmp2_) : NULL);
	x11_window = _tmp3_;
	_tmp4_ = x11_window;
	if (_tmp4_ != NULL) {
		GdkX11Window* _tmp5_;
		gchar* _tmp6_;
		_tmp5_ = x11_window;
		_tmp6_ = g_strdup_printf ("x11:%x", (guint) gdk_x11_window_get_xid (_tmp5_));
		result = _tmp6_;
		_g_object_unref0 (x11_window);
		_g_object_unref0 (gdk_window);
		return result;
	}
	_tmp7_ = g_strdup ("");
	result = _tmp7_;
	_g_object_unref0 (x11_window);
	_g_object_unref0 (gdk_window);
	return result;
}

static void
background_request_autostart_data_free (gpointer _data)
{
	BackgroundRequestAutostartData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->widget);
	g_slice_free (BackgroundRequestAutostartData, _data_);
}

void
background_request_autostart (GtkWidget* widget,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_)
{
	BackgroundRequestAutostartData* _data_;
	GtkWidget* _tmp0_;
	_data_ = g_slice_new0 (BackgroundRequestAutostartData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, background_request_autostart_data_free);
	_tmp0_ = _g_object_ref0 (widget);
	_g_object_unref0 (_data_->widget);
	_data_->widget = _tmp0_;
	background_request_autostart_co (_data_);
}

gboolean
background_request_autostart_finish (GAsyncResult* _res_)
{
	gboolean result;
	BackgroundRequestAutostartData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	return result;
}

static void
background_request_autostart_ready (GObject* source_object,
                                    GAsyncResult* _res_,
                                    gpointer _user_data_)
{
	BackgroundRequestAutostartData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	background_request_autostart_co (_data_);
}

static gboolean
background_request_autostart_co (BackgroundRequestAutostartData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = gtk_widget_get_toplevel (_data_->widget);
	_data_->_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_data_->_tmp0_, gtk_window_get_type ()) ? ((GtkWindow*) _data_->_tmp0_) : NULL);
	_data_->window = _data_->_tmp1_;
	_data_->_tmp2_ = deja_dup_install_env_instance ();
	_data_->install_env = _data_->_tmp2_;
	_data_->_tmp3_ = _data_->install_env;
	_data_->_tmp4_ = _data_->window;
	_data_->_tmp5_ = background_get_window_handle (_data_->_tmp4_);
	_data_->_tmp6_ = _data_->_tmp5_;
	_data_->_tmp7_ = NULL;
	_data_->_state_ = 1;
	deja_dup_install_env_request_autostart (_data_->_tmp3_, _data_->_tmp6_, background_request_autostart_ready, _data_);
	return FALSE;
	_state_1:
	_data_->_tmp8_ = deja_dup_install_env_request_autostart_finish (_data_->_tmp3_, _data_->_res_, &_data_->_tmp7_);
	_g_free0 (_data_->mitigation);
	_data_->mitigation = _data_->_tmp7_;
	_data_->_tmp9_ = _data_->_tmp8_;
	_g_free0 (_data_->_tmp6_);
	_data_->allowed = _data_->_tmp9_;
	if (!_data_->allowed) {
		_data_->_tmp11_ = _data_->mitigation;
		_data_->_tmp10_ = _data_->_tmp11_ != NULL;
	} else {
		_data_->_tmp10_ = FALSE;
	}
	if (_data_->_tmp10_) {
		_data_->_tmp12_ = _data_->window;
		_data_->_tmp13_ = _data_->mitigation;
		deja_dup_run_error_dialog (_data_->_tmp12_, _ ("Cannot back up automatically"), _data_->_tmp13_);
	}
	_data_->result = _data_->allowed;
	_g_object_unref0 (_data_->install_env);
	_g_free0 (_data_->mitigation);
	_g_object_unref0 (_data_->window);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

Background*
background_construct (GType object_type)
{
	Background * self = NULL;
	self = (Background*) g_object_new (object_type, NULL);
	return self;
}

Background*
background_new (void)
{
	return background_construct (TYPE_BACKGROUND);
}

static void
background_class_init (BackgroundClass * klass,
                       gpointer klass_data)
{
	background_parent_class = g_type_class_peek_parent (klass);
}

static void
background_instance_init (Background * self,
                          gpointer klass)
{
}

/**
 * There are several supported installations, which affect autostarting:
 *
 * Traditional distro package.
 * - We ship an /etc/xdg/autostart file.
 * - After 30 days, we use that autostart to prompt the user to consider backing up.
 * - May or may not support the Background portal, but we don't need or use it.
 *
 * Snap package.
 * - On first start, we make an autostart file in the expected snap user data folder.
 * - No prompt support as a result.
 * - Does not support the Background portal, but we don't need or use it.
 *
 * Flatpak package.
 * - Uses the Background portal when the user enables automatic backups.
 * - Since we can't query permission status, we just ask the portal each time and don't notice revocations.
 */
G_GNUC_NO_INLINE static GType
background_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BackgroundClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) background_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Background), 0, (GInstanceInitFunc) background_instance_init, NULL };
	GType background_type_id;
	background_type_id = g_type_register_static (G_TYPE_OBJECT, "Background", &g_define_type_info, 0);
	return background_type_id;
}

GType
background_get_type (void)
{
	static volatile gsize background_type_id__volatile = 0;
	if (g_once_init_enter (&background_type_id__volatile)) {
		GType background_type_id;
		background_type_id = background_get_type_once ();
		g_once_init_leave (&background_type_id__volatile, background_type_id);
	}
	return background_type_id__volatile;
}

